#define MPH 1
#define KMH 0

#define METRIC 0
#define IMPERIAL 1

#define NARROW 1
#define WIDE 0

#define ON 1
#define OFF 0

//General use variables
int xx=0,yy=0,zz=0,tt=0;
int a,b,c,d,e,f;
Metro MetroTimer = Metro(100); 
int tenthSec=0;
int halfSec=0;
uint8_t tenthSecFlag=1;
int Blink1hz=0; // This is turing on and off at 1hz
int Blink2hz=0; // This is turing on and off at 2hz
int Blink10hz=0; // This is turing on and off at 10hz
int ble=0;
uint8_t rssiTimer=0;
uint8_t accCalibrationTimer=0;
uint8_t magCalibrationTimer=0;
uint8_t eepromWriteTimer=0;

unsigned int allSec=0;

uint8_t ROW=10;
uint8_t COL=3;
uint8_t configPage=MINPAGE;
uint8_t configMode=0;

// For Menu
int cursorPostion;

// For Serial communicatin
int8_t waitStick=0;

uint8_t askPID=0;
uint8_t serialWait=0;
short screenType=WIDE;
short unitSystem=METRIC;

static uint8_t P8[PIDITEMS], I8[PIDITEMS], D8[PIDITEMS];

static uint8_t rcRate8,rcExpo8;
static uint8_t rollPitchRate;
static uint8_t yawRate;
static uint8_t dynThrPID;
static uint8_t thrMid8;
static uint8_t thrExpo8;


#define SERIALBUFFERSIZE 128
static uint8_t serialBuffer[SERIALBUFFERSIZE];   // this hold the imcomming string from serial O string
uint8_t serialMSPStringOK=0;
uint8_t receiverIndex=0;
static uint16_t  MwAccSmooth[3]={
  0,0,0};     // Those will hold Accelerator data
//static uint16_t MwGyroSmooth[3]={0,0,0};    // Those will hold Gyroscope Angle
int32_t  MwAltitude=0;                                      // This hold barometric value
// This hold headting to north
int MwAngle[2]={
  0,0};     // Those will hold Accelerator Angle
//static uint16_t MwMotor[6]={0,0,0,0,0,0} ;                 // This hold motor speed signal
static uint16_t MwRcData[8]={
  1500,1500,1500,1500,1500,1500,1500,1500} 
; // This hold receiver pulse signal
//static uint16_t MwMotData[8]={1000,1000,1000,1000,1000,1000,1000,1000};
uint16_t  MwSensorPresent=0;
uint32_t  MwSensorActive=0;
uint8_t MwVersion=0;
//uint8_t MvMultitype=0;
uint8_t  MwVBat=0;
int16_t MwVario=0;
uint8_t armed=0;
int16_t armedTimer=0;
int16_t GPS_distanceToHome=0;
uint8_t GPSPresent=0;
uint8_t GPS_fix=0;
int32_t GPS_latitude;
int32_t GPS_longitude;
int16_t GPS_altitude;
int16_t GPS_speed;
int16_t GPS_ground_course;

uint8_t GPS_update=0;
int16_t GPS_directionToHome=0;
uint8_t GPS_numSat=0;
int16_t I2CError=0;
int16_t cycleTime=0;
int16_t pMeterSum=0;

// For Time
uint8_t onMinute=0;
uint8_t onSecond=0;
uint8_t flyMinute=0;
uint8_t flySecond=0;

// For Heading
char headGraph[]={
  0x1b,0x1d,0x1c,0x1d,0x19,0x1d,0x1c,0x1d,0x1B,0x1d,0x1c,0x1d,0x18,0x1d,0x1c,0x1d,0x1A,0x1d,0x1c,0x1d,0x19,0x1D,0x1c,0x1d};
static uint16_t MwHeading=0;

// For Amperage
float amperage =0.0;  // its the real value x10
float amperageConsumed = pMeterSum; 
//uint16_t enablepMeterSum=1;


// Rssi
int rssi =0;
int rssiADC=0;
int rssiMin;
int rssiMax;    
int rssi_Int=0;  // intermediare value
uint8_t enableRSSI=1;

// For Voltage
float voltage=0; // its the real value x10
uint8_t enableVoltage=1;
uint8_t lowVoltage=99; // x10 volts

// For temprature
float temperature=0; // its the real value x10
uint8_t enableTemperature=1;
uint8_t highTemperature=50;  // Celcius or Fahrenheit

uint8_t displayGPS=1;
uint8_t enableBuzzer=1;
uint8_t armedtimeWarning=6; // Minutes


// For Altitude
int holdRelativeAltitude=0;
char altitudeOk=0;
//int altitudeMax;
int absoluteAltitudeAtStart = 0;
int altitude =1;
int32_t oldMwAltitude=0;
float climbRate = 0;

// For Statistics
int16_t speedMAX=0;
int8_t temperMAX=0;
int16_t altitudeMAX=0;
int16_t distanceMAX=0;
int16_t trip=0;
uint8_t flyingMinute=0;
uint8_t flyingSecond=0;

// ---------------------------------------------------------------------------------------
// Defines imported from Multiwii Serial Protocol 0 MultiWii_release_candidate_2_1_r949 
#define MSP_VERSION        	 0

#define MSP_IDENT                100   //out message         multitype + multiwii version + protocol version + capability variable
#define MSP_STATUS               101   //out message         cycletime & errors_count & sensor present & box activation
#define MSP_RAW_IMU              102   //out message         9 DOF
#define MSP_SERVO                103   //out message         8 servos
#define MSP_MOTOR                104   //out message         8 motors
#define MSP_RC                   105   //out message         8 rc chan
#define MSP_RAW_GPS              106   //out message         fix, numsat, lat, lon, alt, speed
#define MSP_COMP_GPS             107   //out message         distance home, direction home
#define MSP_ATTITUDE             108   //out message         2 angles 1 heading
#define MSP_ALTITUDE             109   //out message         1 altitude
#define MSP_BAT                  110   //out message         vbat, powermetersum
#define MSP_RC_TUNING            111   //out message         rc rate, rc expo, rollpitch rate, yaw rate, dyn throttle PID
#define MSP_PID                  112   //out message         up to 16 P I D (8 are used)
#define MSP_BOX                  113   //out message         up to 16 checkbox (11 are used)
#define MSP_MISC                 114   //out message         powermeter trig + 8 free for future use
#define MSP_MOTOR_PINS           115   //out message         which pins are in use for motors & servos, for GUI 
#define MSP_BOXNAMES             116   //out message         the aux switch names
#define MSP_PIDNAMES             117   //out message         the PID names
#define MSP_WP                   118   //out message         get a WP, WP# is in the payload, returns (WP#, lat, lon, alt, flags) WP#0-home, WP#16-poshold

#define MSP_SET_RAW_RC           200   //in message          8 rc chan
#define MSP_SET_RAW_GPS          201   //in message          fix, numsat, lat, lon, alt, speed
#define MSP_SET_PID              202   //in message          up to 16 P I D (8 are used)
#define MSP_SET_BOX              203   //in message          up to 16 checkbox (11 are used)
#define MSP_SET_RC_TUNING        204   //in message          rc rate, rc expo, rollpitch rate, yaw rate, dyn throttle PID
#define MSP_ACC_CALIBRATION      205   //in message          no param
#define MSP_MAG_CALIBRATION      206   //in message          no param
#define MSP_SET_MISC             207   //in message          powermeter trig + 8 free for future use
#define MSP_RESET_CONF           208   //in message          no param
#define MSP_WP_SET               209   //in message          sets a given WP (WP#,lat, lon, alt, flags)
#define MSP_SELECT_SETTING       210   //in message          Select Setting Number (0-2)

#define MSP_SPEK_BIND            240   //in message          no param

#define MSP_EEPROM_WRITE         250   //in message          no param

#define MSP_DEBUGMSG             253   //out message         debug string buffer
#define MSP_DEBUG                254   //out message         debug1,debug2,debug3,debug4

// End of imported defines from Multiwii Serial Protocol 0 MultiWii_release_candidate_2_1_r949 
// ---------------------------------------------------------------------------------------

// For Intro
prog_char message0[] PROGMEM = "Rushduino MTK";
prog_char message1[] PROGMEM = "Video signal: NTSC";
prog_char message2[] PROGMEM = "Video signal: PAL";
prog_char message3[] PROGMEM = "Screen Type: WIDE";
prog_char message4[] PROGMEM = "Screen Type: NARROW";
prog_char message5[] PROGMEM = "Version:";
prog_char message6[] PROGMEM = "MENU:THRT MIDDLE";
prog_char message7[] PROGMEM = "YAW RIGHT";
prog_char message8[] PROGMEM = "PITCH FULL";
prog_char message9[] PROGMEM = "Minim-OSD";

const char* introMessages[] PROGMEM = {
  message0, message1, message2, message3, message4, message5, message6, message7, message8, message9};

// For Config
prog_char configMsg0[] PROGMEM = "EXIT";
prog_char configMsg1[] PROGMEM = "SaveExit";
prog_char configMsg2[] PROGMEM = "<Page>";
//-----------------------------------------------------------Page1
prog_char configMsg3[] PROGMEM = "1/6 PID CONFIG";
prog_char configMsg4[] PROGMEM = "ROLL";
prog_char configMsg5[] PROGMEM = "PITCH";
prog_char configMsg6[] PROGMEM = "YAW";
prog_char configMsg7[] PROGMEM = "ALT";
prog_char configMsg8[] PROGMEM = "GPS";
prog_char configMsg9[] PROGMEM = "LEVEL";
prog_char configMsg10[] PROGMEM = "MAG";
//-----------------------------------------------------------Page2
prog_char configMsg11[] PROGMEM = "2/6 RC TUNING";
prog_char configMsg12[] PROGMEM = "RC RATE";
prog_char configMsg13[] PROGMEM = "EXPO";
prog_char configMsg14[] PROGMEM = "ROLL PITCH RATE";
prog_char configMsg15[] PROGMEM = "YAW RATE";
prog_char configMsg16[] PROGMEM = "THROTTLE PID ATT";
prog_char configMsg17[] PROGMEM = "MwCycle Time";
prog_char configMsg18[] PROGMEM = "MwI2C Errors";
//-----------------------------------------------------------Page3
prog_char configMsg19[] PROGMEM = "3/6 DISPLAY & ALARM";
prog_char configMsg20[] PROGMEM = "BUZZER";
prog_char configMsg21[] PROGMEM = "ON";
prog_char configMsg22[] PROGMEM = "OFF";
prog_char configMsg23[] PROGMEM = "Display Voltage";
prog_char configMsg24[] PROGMEM = "SET ALARM VOLTAGE";
prog_char configMsg25[] PROGMEM = "Display Temperature";
prog_char configMsg26[] PROGMEM = "SET ALARM TEMP";
prog_char configMsg27[] PROGMEM = "Display GPS";
prog_char configMsg28[] PROGMEM = "SET ALARM ARMED T:";
prog_char configMsg29[] PROGMEM = " ";
prog_char configMsg30[] PROGMEM = "                   ";
//-----------------------------------------------------------Page4
prog_char configMsg31[] PROGMEM = "4/6 DISPLAY";
prog_char configMsg32[] PROGMEM = "Actual RSSIADC(/4)";
prog_char configMsg33[] PROGMEM = "Actual RSSI";
prog_char configMsg34[] PROGMEM = "SET RSSI MIN";
prog_char configMsg35[] PROGMEM = "SET RSSI MAX";
prog_char configMsg36[] PROGMEM = "Display RSSI";
prog_char configMsg37[] PROGMEM = "UNIT SYSTEM";
prog_char configMsg38[] PROGMEM = "METRIC";
prog_char configMsg39[] PROGMEM = "IMPERL";
prog_char configMsg40[] PROGMEM = "Screen Type";
prog_char configMsg41[] PROGMEM = "NARROW";
prog_char configMsg42[] PROGMEM = "WIDE";
//-----------------------------------------------------------Page5
prog_char configMsg43[] PROGMEM = "5/6 CALIBRATION";
prog_char configMsg44[] PROGMEM = "ACC Calibration";
prog_char configMsg45[] PROGMEM = "ACC ROLL :";
prog_char configMsg46[] PROGMEM = "ACC PITCH :";
prog_char configMsg47[] PROGMEM = "ACC Z :";
prog_char configMsg48[] PROGMEM = "MAG Calibration";
prog_char configMsg49[] PROGMEM = "Heading";
prog_char configMsg50[] PROGMEM = "MW EEPROM Write";
//-----------------------------------------------------------Page6
prog_char configMsg51[] PROGMEM = "6/6 STATISTICS";
prog_char configMsg52[] PROGMEM = "TRIP:";
prog_char configMsg53[] PROGMEM = "Max DisToHome:";
prog_char configMsg54[] PROGMEM = "Max Altitude:";
prog_char configMsg55[] PROGMEM = "Max Speed:";
prog_char configMsg56[] PROGMEM = "Flying Time:";
prog_char configMsg57[] PROGMEM = "Consumed Amp.:";
prog_char configMsg58[] PROGMEM = "Max Temp.:";

const char* configMsgs[] PROGMEM = {
  configMsg0, configMsg1, configMsg2, configMsg3, configMsg4, configMsg5, configMsg6, configMsg7, configMsg8, configMsg9, configMsg10,
  configMsg11, configMsg12, configMsg13, configMsg14, configMsg15, configMsg16, configMsg17,   configMsg18, configMsg19, configMsg20,
  configMsg21, configMsg22, configMsg23, configMsg24, configMsg25, configMsg26, configMsg27, configMsg28, configMsg29, configMsg30,
  configMsg31, configMsg32, configMsg33, configMsg34, configMsg35, configMsg36, configMsg37, configMsg38, configMsg39, configMsg40,
  configMsg41, configMsg42, configMsg43, configMsg44, configMsg45, configMsg46, configMsg47, configMsg48, configMsg49, configMsg50,
  configMsg51, configMsg52, configMsg53, configMsg54, configMsg55, configMsg56, configMsg57, configMsg58};








